"use strict";function _typeof(e){"@babel/helpers - typeof";return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}var _loaderUtils=_interopRequireDefault(require("loader-utils")),_path=_interopRequireDefault(require("path")),_fs=_interopRequireDefault(require("fs")),legacy=_interopRequireWildcard(require("./legacy")),_parser=require("./parser"),_util=require("./util"),_component_validator=require("./templater/component_validator");function _getRequireWildcardCache(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return _getRequireWildcardCache=function(){return e},e}function _interopRequireWildcard(e){if(e&&e.__esModule)return e;if(null===e||"object"!==_typeof(e)&&"function"!=typeof e)return{default:e};var t=_getRequireWildcardCache();if(t&&t.has(e))return t.get(e);var a={},r=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var n in e)if(Object.prototype.hasOwnProperty.call(e,n)){var o=r?Object.getOwnPropertyDescriptor(e,n):null;o&&(o.get||o.set)?Object.defineProperty(a,n,o):a[n]=e[n]}return a.default=e,t&&t.set(e,a),a}function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}var _require=require("./lite/lite-enum"),DEVICE_LEVEL=_require.DEVICE_LEVEL,loaderPath=__dirname,defaultLoaders={none:"",main:_path.default.resolve(loaderPath,"loader.js"),extract:_path.default.resolve(loaderPath,"extract.js"),template:_path.default.resolve(loaderPath,"template.js"),style:_path.default.resolve(loaderPath,"style.js"),script:_path.default.resolve(loaderPath,"script.js"),json:_path.default.resolve(loaderPath,"json.js"),babel:(0,_util.loadBabelModule)("babel-loader"),manifest:_path.default.resolve(loaderPath,"manifest-loader.js"),resourceReferenceScript:_path.default.resolve(loaderPath,"resource-reference-script.js")};function getLoaderString(e,t){var a=loadCustomLoader(t=t||{});switch(e){case"main":return mainLoaderString(void 0);case"element":return elementLoaderString(void 0,t);case"template":return templateLoaderString(void 0,t,a);case"style":return styleLoaderString(void 0,t,a);case"script":return scriptLoaderString(void 0,t,a);case"config":return configLoaderString(void 0,t);case"data":return dataLoaderString(void 0,t);default:return}}function loadCustomLoader(e){if(e.lang&&e.customLang[e.lang])return(0,_util.loadBabelModule)(e.customLang[e.lang][0])}function mainLoaderString(e){return e=[{name:defaultLoaders.main}],(0,_util.stringifyLoaders)(e)}function elementLoaderString(e,t){return e=[{name:defaultLoaders.main,query:{element:!t.source||void 0}}],t.source||e.push({name:defaultLoaders.extract,query:{index:t.name,type:"elements"}}),(0,_util.stringifyLoaders)(e)}function templateLoaderString(e,t,a){return e=[{name:defaultLoaders.json},{name:defaultLoaders.template}],a&&(e=e.concat(a)),t.source||e.push({name:defaultLoaders.extract,query:{type:"template"}}),t.element&&e.push({name:defaultLoaders.extract,query:{index:t.elementName,type:"elements"}}),(0,_util.stringifyLoaders)(e)}function styleLoaderString(e,t,a){return e=[{name:defaultLoaders.json},{name:defaultLoaders.style}],a&&(e=e.concat(a)),t.source||e.push({name:defaultLoaders.extract,query:{index:0,type:"styles"}}),t.element&&e.push({name:defaultLoaders.extract,query:{index:t.elementName,type:"elements"}}),(0,_util.stringifyLoaders)(e)}function scriptLoaderString(e,t,a){return e=[{name:defaultLoaders.script}],a?e=e.concat(a):(e.push({name:defaultLoaders.babel,query:{presets:[(0,_util.loadBabelModule)("@babel/preset-env")],plugins:[(0,_util.loadBabelModule)("@babel/plugin-transform-modules-commonjs")],comments:"false"}}),e.push({name:defaultLoaders.resourceReferenceScript})),t.source||e.push({name:defaultLoaders.extract,query:{index:0,type:"scripts"}}),t.element&&e.push({name:defaultLoaders.extract,query:{index:t.elementName,type:"elements"}}),t.app&&e.push({name:defaultLoaders.manifest,query:{path:t.source}}),(0,_util.stringifyLoaders)(e)}function configLoaderString(e,t){return e=[{name:defaultLoaders.json}],t.source||e.push({name:defaultLoaders.extract,query:{type:"config"}}),(0,_util.stringifyLoaders)(e)}function dataLoaderString(e,t){return e=[{name:defaultLoaders.json}],t.source||e.push({name:defaultLoaders.extract,query:{type:"data"}}),(0,_util.stringifyLoaders)(e)}function loader(e){this.cacheable&&this.cacheable();var t=(this._compiler.options.plugins[0].options.options.weex||{}).lang||{},a=this.resourceQuery&&_loaderUtils.default.parseQuery(this.resourceQuery)||{},r=a.entry,n=_path.default.parse(this.resourcePath),o=r?n.name:a.name||(0,_util.getNameByPath)(this.resourcePath);if((0,_component_validator.isReservedTag)(o))return(0,_util.logWarn)(this,[{reason:"ERROR: The file name cannot contain reserved tag name: "+o}]),"";var s="";return s+=loadApp(this,o,r,t),s+=loadPage(this,o,r,t,e)}function loadApp(e,t,a,r){var n="",o=!1;if(e.resourcePath.indexOf("app.js")>0){var s=e.resourcePath.replace(_path.default.extname(e.resourcePath).toString(),"")+".css";return _fs.default.existsSync(s)?(o=!0,n+="var $app_style$ = "+(0,_util.getRequireString)(e,getLoaderString("style",{customLang:r,lang:void 0,element:void 0,elementName:void 0,source:s}),s)):o=!1,n+="var $app_script$ = "+(0,_util.getRequireString)(e,getLoaderString("script",{customLang:r,lang:void 0,element:void 0,elementName:void 0,source:e.resourcePath,app:!0}),e.resourcePath),process.env.DEVICE_LEVEL===DEVICE_LEVEL.RICH&&(n+="\n      $app_define$('@app-application/".concat(t,"', [], function($app_require$, $app_exports$, $app_module$) {\n      ")+"\n      $app_script$($app_module$, $app_exports$, $app_require$)\n      if ($app_exports$.__esModule && $app_exports$.default) {\n        $app_module$.exports = $app_exports$.default\n      }\n      "+(o?"\n      $app_module$.exports.style = $app_style$\n      ":"")+"\n      })\n      ",a&&(n+="$app_bootstrap$('@app-application/".concat(t,"'")+",undefined,undefined)")),process.env.DEVICE_LEVEL===DEVICE_LEVEL.LITE&&(n+="var options=$app_script$\n if ($app_script$.__esModule) {\n\n        options = $app_script$.default;\n }\n"+(o?"options.styleSheet=$app_style$\n":"")+"module.exports=new ViewModel(options);"),n}return n}function loadPage(e,t,a,r,n){var o="";if(_path.default.extname(e.resourcePath).match(/\.hml/)){var s=e.resourcePath.replace(_path.default.extname(e.resourcePath).toString(),""),i=e.resourcePath,l=(_loaderUtils.default.getOptions(e)||{}).element,u=(0,_parser.parseFragment)(n);o+=loadPageCheckElementLength(e,u.element.length,u,[],i,r),o+="var $app_template$ = "+(0,_util.getRequireString)(e,getLoaderString("template",{customLang:r,lang:void 0,element:l,elementName:l?t:void 0,source:e.resourcePath}),e.resourcePath);var p=loadPageFindCss(e,s,r),d=p.extcss;o+=p.output;var c=loadPageFindJs(e,s,r),m=c.extscript;return o+=c.output,o+=process.env.DEVICE_LEVEL===DEVICE_LEVEL.RICH?loadPageCheckRich(t,m,d,a):loadPageCheckLite(m,d)}return o}function loadPageCheckElementLength(e,t,a,r,n,o){var s="";if(t)for(var i=0;i<t;i++){var l=a.element[i],u=n;if(!l.src)return(0,_util.logWarn)(e,[{reason:"ERROR: src attributes must be set for custom elements."}]);(u=l.src).match(/\.hml$/)||(u=u.concat(".hml"));var p=_path.default.join(_path.default.dirname(n),u);if(!_fs.default.existsSync(p))return(0,_util.logWarn)(e,[{reason:"ERROR: The file path of custom element does not exist, src: "+u}]);l.name||(l.name=_path.default.parse(u).name),r.push(l.name),s+=(0,_util.getRequireString)(e,getLoaderString("element",{customLang:o,name:l.name,source:l.src}),"".concat(u,"?name=").concat(l.name.toLowerCase()))}return s}function loadPageFindCss(e,t,a){var r="",n=!1,o=t+".css";if(_fs.default.existsSync(o))n=!0,r="var $app_style$ = "+(0,_util.getRequireString)(e,getLoaderString("style",{customLang:a,lang:void 0,element:void 0,elementName:void 0,source:o}),o);else{var s=t+".less";if(_fs.default.existsSync(s))n=!0,r="var $app_style$ = "+(0,_util.getRequireString)(e,getLoaderString("style",{customLang:a,lang:"less",element:void 0,elementName:void 0,source:s}),s);else{var i=t+".scss";if(_fs.default.existsSync(i))n=!0,r="var $app_style$ = "+(0,_util.getRequireString)(e,getLoaderString("style",{customLang:a,lang:"scss",element:void 0,elementName:void 0,source:i}),i);else{var l=t+".sass";_fs.default.existsSync(l)?(n=!0,r="var $app_style$ = "+(0,_util.getRequireString)(e,getLoaderString("style",{customLang:a,lang:"sass",element:void 0,elementName:void 0,source:l}),l)):n=!1}}}return{extcss:n,output:r}}function loadPageFindJs(e,t,a){var r="",n=!1,o=t+".js";return _fs.default.existsSync(o)?(n=!0,r="var $app_script$ = "+(0,_util.getRequireString)(e,getLoaderString("script",{customLang:a,lang:void 0,element:void 0,elementName:void 0,source:o}),o)):(n=!1,console.log("missing "+o)),{extscript:n,output:r}}function loadPageCheckRich(e,t,a,r){var n="";return n+="\n$app_define$('@app-component/".concat(e,"', [], function($app_require$, $app_exports$, $app_module$) {\n")+(t?"\n$app_script$($app_module$, $app_exports$, $app_require$)\nif ($app_exports$.__esModule && $app_exports$.default) {\n$app_module$.exports = $app_exports$.default\n}\n":"")+"\n$app_module$.exports.template = $app_template$\n"+(a?"\n$app_module$.exports.style = $app_style$\n":"")+"\n})\n",r&&(n+="$app_bootstrap$('@app-component/".concat(e,"'")+",undefined,undefined)"),n}function loadPageCheckLite(e,t){return(e?"var options=$app_script$\n if ($app_script$.__esModule) {\n\n      options = $app_script$.default;\n }\n":"var options={}\n")+(t?"options.styleSheet=$app_style$\n":"")+"options.render=$app_template$;\nmodule.exports=new ViewModel(options);"}for(var key in legacy)loader[key]=legacy[key];module.exports=loader;