"use strict";const Tokenizer=require("../tokenizer"),HTML=require("./html"),$=HTML.TAG_NAMES,NS=HTML.NAMESPACES,ATTRS=HTML.ATTRS,MIME_TYPES={TEXT_HTML:"text/html",APPLICATION_XML:"application/xhtml+xml"},DEFINITION_URL_ATTR="definitionurl",ADJUSTED_DEFINITION_URL_ATTR="definitionURL",SVG_ATTRS_ADJUSTMENT_MAP={attributename:"attributeName",attributetype:"attributeType",basefrequency:"baseFrequency",baseprofile:"baseProfile",calcmode:"calcMode",clippathunits:"clipPathUnits",diffuseconstant:"diffuseConstant",edgemode:"edgeMode",filterunits:"filterUnits",glyphref:"glyphRef",gradienttransform:"gradientTransform",gradientunits:"gradientUnits",kernelmatrix:"kernelMatrix",kernelunitlength:"kernelUnitLength",keypoints:"keyPoints",keysplines:"keySplines",keytimes:"keyTimes",lengthadjust:"lengthAdjust",limitingconeangle:"limitingConeAngle",markerheight:"markerHeight",markerunits:"markerUnits",markerwidth:"markerWidth",maskcontentunits:"maskContentUnits",maskunits:"maskUnits",numoctaves:"numOctaves",pathlength:"pathLength",patterncontentunits:"patternContentUnits",patterntransform:"patternTransform",patternunits:"patternUnits",pointsatx:"pointsAtX",pointsaty:"pointsAtY",pointsatz:"pointsAtZ",preservealpha:"preserveAlpha",preserveaspectratio:"preserveAspectRatio",primitiveunits:"primitiveUnits",refx:"refX",refy:"refY",repeatcount:"repeatCount",repeatdur:"repeatDur",requiredextensions:"requiredExtensions",requiredfeatures:"requiredFeatures",specularconstant:"specularConstant",specularexponent:"specularExponent",spreadmethod:"spreadMethod",startoffset:"startOffset",stddeviation:"stdDeviation",stitchtiles:"stitchTiles",surfacescale:"surfaceScale",systemlanguage:"systemLanguage",tablevalues:"tableValues",targetx:"targetX",targety:"targetY",textlength:"textLength",viewbox:"viewBox",viewtarget:"viewTarget",xchannelselector:"xChannelSelector",ychannelselector:"yChannelSelector",zoomandpan:"zoomAndPan"},XML_ATTRS_ADJUSTMENT_MAP={"xlink:actuate":{prefix:"xlink",name:"actuate",namespace:NS.XLINK},"xlink:arcrole":{prefix:"xlink",name:"arcrole",namespace:NS.XLINK},"xlink:href":{prefix:"xlink",name:"href",namespace:NS.XLINK},"xlink:role":{prefix:"xlink",name:"role",namespace:NS.XLINK},"xlink:show":{prefix:"xlink",name:"show",namespace:NS.XLINK},"xlink:title":{prefix:"xlink",name:"title",namespace:NS.XLINK},"xlink:type":{prefix:"xlink",name:"type",namespace:NS.XLINK},"xml:base":{prefix:"xml",name:"base",namespace:NS.XML},"xml:lang":{prefix:"xml",name:"lang",namespace:NS.XML},"xml:space":{prefix:"xml",name:"space",namespace:NS.XML},xmlns:{prefix:"",name:"xmlns",namespace:NS.XMLNS},"xmlns:xlink":{prefix:"xmlns",name:"xlink",namespace:NS.XMLNS}},SVG_TAG_NAMES_ADJUSTMENT_MAP=exports.SVG_TAG_NAMES_ADJUSTMENT_MAP={altglyph:"altGlyph",altglyphdef:"altGlyphDef",altglyphitem:"altGlyphItem",animatecolor:"animateColor",animatemotion:"animateMotion",animatetransform:"animateTransform",clippath:"clipPath",feblend:"feBlend",fecolormatrix:"feColorMatrix",fecomponenttransfer:"feComponentTransfer",fecomposite:"feComposite",feconvolvematrix:"feConvolveMatrix",fediffuselighting:"feDiffuseLighting",fedisplacementmap:"feDisplacementMap",fedistantlight:"feDistantLight",feflood:"feFlood",fefunca:"feFuncA",fefuncb:"feFuncB",fefuncg:"feFuncG",fefuncr:"feFuncR",fegaussianblur:"feGaussianBlur",feimage:"feImage",femerge:"feMerge",femergenode:"feMergeNode",femorphology:"feMorphology",feoffset:"feOffset",fepointlight:"fePointLight",fespecularlighting:"feSpecularLighting",fespotlight:"feSpotLight",fetile:"feTile",feturbulence:"feTurbulence",foreignobject:"foreignObject",glyphref:"glyphRef",lineargradient:"linearGradient",radialgradient:"radialGradient",textpath:"textPath"},EXITS_FOREIGN_CONTENT={[$.B]:!0,[$.BIG]:!0,[$.BLOCKQUOTE]:!0,[$.BODY]:!0,[$.BR]:!0,[$.CENTER]:!0,[$.CODE]:!0,[$.DD]:!0,[$.DIV]:!0,[$.DL]:!0,[$.DT]:!0,[$.EM]:!0,[$.EMBED]:!0,[$.H1]:!0,[$.H2]:!0,[$.H3]:!0,[$.H4]:!0,[$.H5]:!0,[$.H6]:!0,[$.HEAD]:!0,[$.HR]:!0,[$.I]:!0,[$.IMG]:!0,[$.LI]:!0,[$.LISTING]:!0,[$.MENU]:!0,[$.META]:!0,[$.NOBR]:!0,[$.OL]:!0,[$.P]:!0,[$.PRE]:!0,[$.RUBY]:!0,[$.S]:!0,[$.SMALL]:!0,[$.SPAN]:!0,[$.STRONG]:!0,[$.STRIKE]:!0,[$.SUB]:!0,[$.SUP]:!0,[$.TABLE]:!0,[$.TT]:!0,[$.U]:!0,[$.UL]:!0,[$.VAR]:!0};function isMathMLTextIntegrationPoint(e,t){return t===NS.MATHML&&(e===$.MI||e===$.MO||e===$.MN||e===$.MS||e===$.MTEXT)}function isHtmlIntegrationPoint(e,t,n){if(t===NS.MATHML&&e===$.ANNOTATION_XML)for(let e=0;e<n.length;e++)if(n[e].name===ATTRS.ENCODING){const t=n[e].value.toLowerCase();return t===MIME_TYPES.TEXT_HTML||t===MIME_TYPES.APPLICATION_XML}return t===NS.SVG&&(e===$.FOREIGN_OBJECT||e===$.DESC||e===$.TITLE)}exports.causesExit=function(e){const t=e.tagName;return!!(t===$.FONT&&(null!==Tokenizer.getTokenAttr(e,ATTRS.COLOR)||null!==Tokenizer.getTokenAttr(e,ATTRS.SIZE)||null!==Tokenizer.getTokenAttr(e,ATTRS.FACE)))||EXITS_FOREIGN_CONTENT[t]},exports.adjustTokenMathMLAttrs=function(e){for(let t=0;t<e.attrs.length;t++)if("definitionurl"===e.attrs[t].name){e.attrs[t].name="definitionURL";break}},exports.adjustTokenSVGAttrs=function(e){for(let t=0;t<e.attrs.length;t++){const n=SVG_ATTRS_ADJUSTMENT_MAP[e.attrs[t].name];n&&(e.attrs[t].name=n)}},exports.adjustTokenXMLAttrs=function(e){for(let t=0;t<e.attrs.length;t++){const n=XML_ATTRS_ADJUSTMENT_MAP[e.attrs[t].name];n&&(e.attrs[t].prefix=n.prefix,e.attrs[t].name=n.name,e.attrs[t].namespace=n.namespace)}},exports.adjustTokenSVGTagName=function(e){const t=SVG_TAG_NAMES_ADJUSTMENT_MAP[e.tagName];t&&(e.tagName=t)},exports.isIntegrationPoint=function(e,t,n,a){return!(a&&a!==NS.HTML||!isHtmlIntegrationPoint(e,t,n))||!(a&&a!==NS.MATHML||!isMathMLTextIntegrationPoint(e,t))};