"use strict";const Tokenizer=require("../tokenizer"),OpenElementStack=require("./open-element-stack"),FormattingElementList=require("./formatting-element-list"),LocationInfoParserMixin=require("../extensions/location-info/parser-mixin"),ErrorReportingParserMixin=require("../extensions/error-reporting/parser-mixin"),Mixin=require("../utils/mixin"),defaultTreeAdapter=require("../tree-adapters/default"),mergeOptions=require("../utils/merge-options"),doctype=require("../common/doctype"),foreignContent=require("../common/foreign-content"),ERR=require("../common/error-codes"),unicode=require("../common/unicode"),HTML=require("../common/html"),$=HTML.TAG_NAMES,NS=HTML.NAMESPACES,ATTRS=HTML.ATTRS,DEFAULT_OPTIONS={scriptingEnabled:!0,sourceCodeLocationInfo:!1,onParseError:null,treeAdapter:defaultTreeAdapter},HIDDEN_INPUT_TYPE="hidden",AA_OUTER_LOOP_ITER=8,AA_INNER_LOOP_ITER=3,INITIAL_MODE="INITIAL_MODE",BEFORE_HTML_MODE="BEFORE_HTML_MODE",BEFORE_HEAD_MODE="BEFORE_HEAD_MODE",IN_HEAD_MODE="IN_HEAD_MODE",IN_HEAD_NO_SCRIPT_MODE="IN_HEAD_NO_SCRIPT_MODE",AFTER_HEAD_MODE="AFTER_HEAD_MODE",IN_BODY_MODE="IN_BODY_MODE",TEXT_MODE="TEXT_MODE",IN_TABLE_MODE="IN_TABLE_MODE",IN_TABLE_TEXT_MODE="IN_TABLE_TEXT_MODE",IN_CAPTION_MODE="IN_CAPTION_MODE",IN_COLUMN_GROUP_MODE="IN_COLUMN_GROUP_MODE",IN_TABLE_BODY_MODE="IN_TABLE_BODY_MODE",IN_ROW_MODE="IN_ROW_MODE",IN_CELL_MODE="IN_CELL_MODE",IN_SELECT_MODE="IN_SELECT_MODE",IN_SELECT_IN_TABLE_MODE="IN_SELECT_IN_TABLE_MODE",IN_TEMPLATE_MODE="IN_TEMPLATE_MODE",AFTER_BODY_MODE="AFTER_BODY_MODE",IN_FRAMESET_MODE="IN_FRAMESET_MODE",AFTER_FRAMESET_MODE="AFTER_FRAMESET_MODE",AFTER_AFTER_BODY_MODE="AFTER_AFTER_BODY_MODE",AFTER_AFTER_FRAMESET_MODE="AFTER_AFTER_FRAMESET_MODE",INSERTION_MODE_RESET_MAP={[$.TR]:IN_ROW_MODE,[$.TBODY]:IN_TABLE_BODY_MODE,[$.THEAD]:IN_TABLE_BODY_MODE,[$.TFOOT]:IN_TABLE_BODY_MODE,[$.CAPTION]:IN_CAPTION_MODE,[$.COLGROUP]:IN_COLUMN_GROUP_MODE,[$.TABLE]:IN_TABLE_MODE,[$.BODY]:IN_BODY_MODE,[$.FRAMESET]:IN_FRAMESET_MODE},TEMPLATE_INSERTION_MODE_SWITCH_MAP={[$.CAPTION]:IN_TABLE_MODE,[$.COLGROUP]:IN_TABLE_MODE,[$.TBODY]:IN_TABLE_MODE,[$.TFOOT]:IN_TABLE_MODE,[$.THEAD]:IN_TABLE_MODE,[$.COL]:IN_COLUMN_GROUP_MODE,[$.TR]:IN_TABLE_BODY_MODE,[$.TD]:IN_ROW_MODE,[$.TH]:IN_ROW_MODE},TOKEN_HANDLERS={[INITIAL_MODE]:{[Tokenizer.CHARACTER_TOKEN]:tokenInInitialMode,[Tokenizer.NULL_CHARACTER_TOKEN]:tokenInInitialMode,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:doctypeInInitialMode,[Tokenizer.START_TAG_TOKEN]:tokenInInitialMode,[Tokenizer.END_TAG_TOKEN]:tokenInInitialMode,[Tokenizer.EOF_TOKEN]:tokenInInitialMode},[BEFORE_HTML_MODE]:{[Tokenizer.CHARACTER_TOKEN]:tokenBeforeHtml,[Tokenizer.NULL_CHARACTER_TOKEN]:tokenBeforeHtml,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagBeforeHtml,[Tokenizer.END_TAG_TOKEN]:endTagBeforeHtml,[Tokenizer.EOF_TOKEN]:tokenBeforeHtml},[BEFORE_HEAD_MODE]:{[Tokenizer.CHARACTER_TOKEN]:tokenBeforeHead,[Tokenizer.NULL_CHARACTER_TOKEN]:tokenBeforeHead,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:misplacedDoctype,[Tokenizer.START_TAG_TOKEN]:startTagBeforeHead,[Tokenizer.END_TAG_TOKEN]:endTagBeforeHead,[Tokenizer.EOF_TOKEN]:tokenBeforeHead},[IN_HEAD_MODE]:{[Tokenizer.CHARACTER_TOKEN]:tokenInHead,[Tokenizer.NULL_CHARACTER_TOKEN]:tokenInHead,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:insertCharacters,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:misplacedDoctype,[Tokenizer.START_TAG_TOKEN]:startTagInHead,[Tokenizer.END_TAG_TOKEN]:endTagInHead,[Tokenizer.EOF_TOKEN]:tokenInHead},[IN_HEAD_NO_SCRIPT_MODE]:{[Tokenizer.CHARACTER_TOKEN]:tokenInHeadNoScript,[Tokenizer.NULL_CHARACTER_TOKEN]:tokenInHeadNoScript,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:insertCharacters,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:misplacedDoctype,[Tokenizer.START_TAG_TOKEN]:startTagInHeadNoScript,[Tokenizer.END_TAG_TOKEN]:endTagInHeadNoScript,[Tokenizer.EOF_TOKEN]:tokenInHeadNoScript},[AFTER_HEAD_MODE]:{[Tokenizer.CHARACTER_TOKEN]:tokenAfterHead,[Tokenizer.NULL_CHARACTER_TOKEN]:tokenAfterHead,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:insertCharacters,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:misplacedDoctype,[Tokenizer.START_TAG_TOKEN]:startTagAfterHead,[Tokenizer.END_TAG_TOKEN]:endTagAfterHead,[Tokenizer.EOF_TOKEN]:tokenAfterHead},[IN_BODY_MODE]:{[Tokenizer.CHARACTER_TOKEN]:characterInBody,[Tokenizer.NULL_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:whitespaceCharacterInBody,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInBody,[Tokenizer.END_TAG_TOKEN]:endTagInBody,[Tokenizer.EOF_TOKEN]:eofInBody},[TEXT_MODE]:{[Tokenizer.CHARACTER_TOKEN]:insertCharacters,[Tokenizer.NULL_CHARACTER_TOKEN]:insertCharacters,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:insertCharacters,[Tokenizer.COMMENT_TOKEN]:ignoreToken,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:ignoreToken,[Tokenizer.END_TAG_TOKEN]:endTagInText,[Tokenizer.EOF_TOKEN]:eofInText},[IN_TABLE_MODE]:{[Tokenizer.CHARACTER_TOKEN]:characterInTable,[Tokenizer.NULL_CHARACTER_TOKEN]:characterInTable,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:characterInTable,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInTable,[Tokenizer.END_TAG_TOKEN]:endTagInTable,[Tokenizer.EOF_TOKEN]:eofInBody},[IN_TABLE_TEXT_MODE]:{[Tokenizer.CHARACTER_TOKEN]:characterInTableText,[Tokenizer.NULL_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:whitespaceCharacterInTableText,[Tokenizer.COMMENT_TOKEN]:tokenInTableText,[Tokenizer.DOCTYPE_TOKEN]:tokenInTableText,[Tokenizer.START_TAG_TOKEN]:tokenInTableText,[Tokenizer.END_TAG_TOKEN]:tokenInTableText,[Tokenizer.EOF_TOKEN]:tokenInTableText},[IN_CAPTION_MODE]:{[Tokenizer.CHARACTER_TOKEN]:characterInBody,[Tokenizer.NULL_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:whitespaceCharacterInBody,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInCaption,[Tokenizer.END_TAG_TOKEN]:endTagInCaption,[Tokenizer.EOF_TOKEN]:eofInBody},[IN_COLUMN_GROUP_MODE]:{[Tokenizer.CHARACTER_TOKEN]:tokenInColumnGroup,[Tokenizer.NULL_CHARACTER_TOKEN]:tokenInColumnGroup,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:insertCharacters,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInColumnGroup,[Tokenizer.END_TAG_TOKEN]:endTagInColumnGroup,[Tokenizer.EOF_TOKEN]:eofInBody},[IN_TABLE_BODY_MODE]:{[Tokenizer.CHARACTER_TOKEN]:characterInTable,[Tokenizer.NULL_CHARACTER_TOKEN]:characterInTable,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:characterInTable,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInTableBody,[Tokenizer.END_TAG_TOKEN]:endTagInTableBody,[Tokenizer.EOF_TOKEN]:eofInBody},[IN_ROW_MODE]:{[Tokenizer.CHARACTER_TOKEN]:characterInTable,[Tokenizer.NULL_CHARACTER_TOKEN]:characterInTable,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:characterInTable,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInRow,[Tokenizer.END_TAG_TOKEN]:endTagInRow,[Tokenizer.EOF_TOKEN]:eofInBody},[IN_CELL_MODE]:{[Tokenizer.CHARACTER_TOKEN]:characterInBody,[Tokenizer.NULL_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:whitespaceCharacterInBody,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInCell,[Tokenizer.END_TAG_TOKEN]:endTagInCell,[Tokenizer.EOF_TOKEN]:eofInBody},[IN_SELECT_MODE]:{[Tokenizer.CHARACTER_TOKEN]:insertCharacters,[Tokenizer.NULL_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:insertCharacters,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInSelect,[Tokenizer.END_TAG_TOKEN]:endTagInSelect,[Tokenizer.EOF_TOKEN]:eofInBody},[IN_SELECT_IN_TABLE_MODE]:{[Tokenizer.CHARACTER_TOKEN]:insertCharacters,[Tokenizer.NULL_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:insertCharacters,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInSelectInTable,[Tokenizer.END_TAG_TOKEN]:endTagInSelectInTable,[Tokenizer.EOF_TOKEN]:eofInBody},[IN_TEMPLATE_MODE]:{[Tokenizer.CHARACTER_TOKEN]:characterInBody,[Tokenizer.NULL_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:whitespaceCharacterInBody,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInTemplate,[Tokenizer.END_TAG_TOKEN]:endTagInTemplate,[Tokenizer.EOF_TOKEN]:eofInTemplate},[AFTER_BODY_MODE]:{[Tokenizer.CHARACTER_TOKEN]:tokenAfterBody,[Tokenizer.NULL_CHARACTER_TOKEN]:tokenAfterBody,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:whitespaceCharacterInBody,[Tokenizer.COMMENT_TOKEN]:appendCommentToRootHtmlElement,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagAfterBody,[Tokenizer.END_TAG_TOKEN]:endTagAfterBody,[Tokenizer.EOF_TOKEN]:stopParsing},[IN_FRAMESET_MODE]:{[Tokenizer.CHARACTER_TOKEN]:ignoreToken,[Tokenizer.NULL_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:insertCharacters,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagInFrameset,[Tokenizer.END_TAG_TOKEN]:endTagInFrameset,[Tokenizer.EOF_TOKEN]:stopParsing},[AFTER_FRAMESET_MODE]:{[Tokenizer.CHARACTER_TOKEN]:ignoreToken,[Tokenizer.NULL_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:insertCharacters,[Tokenizer.COMMENT_TOKEN]:appendComment,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagAfterFrameset,[Tokenizer.END_TAG_TOKEN]:endTagAfterFrameset,[Tokenizer.EOF_TOKEN]:stopParsing},[AFTER_AFTER_BODY_MODE]:{[Tokenizer.CHARACTER_TOKEN]:tokenAfterAfterBody,[Tokenizer.NULL_CHARACTER_TOKEN]:tokenAfterAfterBody,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:whitespaceCharacterInBody,[Tokenizer.COMMENT_TOKEN]:appendCommentToDocument,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagAfterAfterBody,[Tokenizer.END_TAG_TOKEN]:tokenAfterAfterBody,[Tokenizer.EOF_TOKEN]:stopParsing},[AFTER_AFTER_FRAMESET_MODE]:{[Tokenizer.CHARACTER_TOKEN]:ignoreToken,[Tokenizer.NULL_CHARACTER_TOKEN]:ignoreToken,[Tokenizer.WHITESPACE_CHARACTER_TOKEN]:whitespaceCharacterInBody,[Tokenizer.COMMENT_TOKEN]:appendCommentToDocument,[Tokenizer.DOCTYPE_TOKEN]:ignoreToken,[Tokenizer.START_TAG_TOKEN]:startTagAfterAfterFrameset,[Tokenizer.END_TAG_TOKEN]:ignoreToken,[Tokenizer.EOF_TOKEN]:stopParsing}};class Parser{constructor(e){this.options=mergeOptions(DEFAULT_OPTIONS,e),this.treeAdapter=this.options.treeAdapter,this.pendingScript=null,this.nodeInfo={},this.options.componentValidator&&(this.validator=this.options.componentValidator),this.options.compileResult&&(this.compileResult=this.options.compileResult),this.options.sourceCodeLocationInfo&&Mixin.install(this,LocationInfoParserMixin),this.options.onParseError&&Mixin.install(this,ErrorReportingParserMixin,{onParseError:this.options.onParseError})}parse(e){const n=this.treeAdapter.createDocument();return this._bootstrap(n,null),this.tokenizer.write(e,!0),this._runParsingLoop(null),n}parseFragment(e,n){n||(n=this.treeAdapter.createElement($.TEMPLATE,NS.HTML,[]));const t=this.treeAdapter.createElement("documentmock",NS.HTML,[]);this._bootstrap(t,n),this.treeAdapter.getTagName(n)===$.TEMPLATE&&this._pushTmplInsertionMode(IN_TEMPLATE_MODE),this._initTokenizerForFragmentParsing(),this._insertFakeRootElement(),this._resetInsertionMode(),this._findFormInFragmentContext(),this.tokenizer.write(e,!0),this._runParsingLoop(null);const o=this.treeAdapter.getFirstChild(t),T=this.treeAdapter.createDocumentFragment();return this._adoptNodes(o,T),T}_bootstrap(e,n){this.tokenizer=new Tokenizer(this.options),this.stopped=!1,this.insertionMode=INITIAL_MODE,this.originalInsertionMode="",this.document=e,this.fragmentContext=n,this.headElement=null,this.formElement=null,this.openElements=new OpenElementStack(this.document,this.treeAdapter),this.activeFormattingElements=new FormattingElementList(this.treeAdapter),this.tmplInsertionModeStack=[],this.tmplInsertionModeStackTop=-1,this.currentTmplInsertionMode=null,this.pendingCharacterTokens=[],this.hasNonWhitespacePendingCharacterToken=!1,this.framesetOk=!0,this.skipNextNewLine=!1,this.fosterParentingEnabled=!1}_err(){}_runParsingLoop(e){let n={};for(;!this.stopped;){this._setupTokenizerCDATAMode();const t=this.tokenizer.getNextToken();if(t.type===Tokenizer.HIBERNATION_TOKEN)break;if(t.type!==Tokenizer.EOF_TOKEN&&t.type!==Tokenizer.WHITESPACE_CHARACTER_TOKEN&&(n=t),checkselfClosingNode(this,t),this.skipNextNewLine&&(this.skipNextNewLine=!1,t.type===Tokenizer.WHITESPACE_CHARACTER_TOKEN&&"\n"===t.chars[0])){if(1===t.chars.length)continue;t.chars=t.chars.substr(1)}if(this._processInputToken(t),e&&this.pendingScript)break}checkInvalid(this,n)}runParsingLoopForCurrentChunk(e,n){if(this._runParsingLoop(n),n&&this.pendingScript){const e=this.pendingScript;return this.pendingScript=null,void n(e)}e&&e()}_setupTokenizerCDATAMode(){const e=this._getAdjustedCurrentElement();this.tokenizer.allowCDATA=e&&e!==this.document&&this.treeAdapter.getNamespaceURI(e)!==NS.HTML&&!this._isIntegrationPoint(e)}_switchToTextParsing(e,n){this._insertElement(e,NS.HTML),this.tokenizer.state=n,this.originalInsertionMode=this.insertionMode,this.insertionMode=TEXT_MODE}switchToPlaintextParsing(){this.insertionMode=TEXT_MODE,this.originalInsertionMode=IN_BODY_MODE,this.tokenizer.state=Tokenizer.MODE.PLAINTEXT}_getAdjustedCurrentElement(){return 0===this.openElements.stackTop&&this.fragmentContext?this.fragmentContext:this.openElements.current}_findFormInFragmentContext(){let e=this.fragmentContext;do{if(this.treeAdapter.getTagName(e)===$.FORM){this.formElement=e;break}e=this.treeAdapter.getParentNode(e)}while(e)}_initTokenizerForFragmentParsing(){if(this.treeAdapter.getNamespaceURI(this.fragmentContext)===NS.HTML){const e=this.treeAdapter.getTagName(this.fragmentContext);e===$.TITLE||e===$.TEXTAREA?this.tokenizer.state=Tokenizer.MODE.RCDATA:e===$.STYLE||e===$.XMP||e===$.IFRAME||e===$.NOEMBED||e===$.NOFRAMES||e===$.NOSCRIPT?this.tokenizer.state=Tokenizer.MODE.RAWTEXT:e===$.SCRIPT?this.tokenizer.state=Tokenizer.MODE.SCRIPT_DATA:e===$.PLAINTEXT&&(this.tokenizer.state=Tokenizer.MODE.PLAINTEXT)}}_setDocumentType(e){const n=e.name||"",t=e.publicId||"",o=e.systemId||"";this.treeAdapter.setDocumentType(this.document,n,t,o)}_attachElementToTree(e){if(this._shouldFosterParentOnInsertion())this._fosterParentElement(e);else{const n=this.openElements.currentTmplContent||this.openElements.current;this.treeAdapter.appendChild(n,e)}}_appendElement(e,n){const t=this.treeAdapter.createElement(e.tagName,n,e.attrs);this._attachElementToTree(t)}_insertElement(e,n){const t=this.treeAdapter.createElement(e.tagName,n,e.attrs);this._attachElementToTree(t),this.openElements.push(t)}_insertFakeElement(e){const n=this.treeAdapter.createElement(e,NS.HTML,[]);this._attachElementToTree(n),this.openElements.push(n)}_insertTemplate(e){const n=this.treeAdapter.createElement(e.tagName,NS.HTML,e.attrs),t=this.treeAdapter.createDocumentFragment();this.treeAdapter.setTemplateContent(n,t),this._attachElementToTree(n),this.openElements.push(n)}_insertFakeRootElement(){const e=this.treeAdapter.createElement($.HTML,NS.HTML,[]);this.treeAdapter.appendChild(this.openElements.current,e),this.openElements.push(e)}_appendCommentNode(e,n){const t=this.treeAdapter.createCommentNode(e.data);this.treeAdapter.appendChild(n,t)}_insertCharacters(e){if(this._shouldFosterParentOnInsertion())this._fosterParentText(e.chars);else{const n=this.openElements.currentTmplContent||this.openElements.current;this.treeAdapter.insertText(n,e.chars)}}_adoptNodes(e,n){for(let t=this.treeAdapter.getFirstChild(e);t;t=this.treeAdapter.getFirstChild(e))this.treeAdapter.detachNode(t),this.treeAdapter.appendChild(n,t)}_shouldProcessTokenInForeignContent(e){const n=this._getAdjustedCurrentElement();if(!n||n===this.document)return!1;const t=this.treeAdapter.getNamespaceURI(n);if(t===NS.HTML)return!1;if(this.treeAdapter.getTagName(n)===$.ANNOTATION_XML&&t===NS.MATHML&&e.type===Tokenizer.START_TAG_TOKEN&&e.tagName===$.SVG)return!1;const o=e.type===Tokenizer.CHARACTER_TOKEN||e.type===Tokenizer.NULL_CHARACTER_TOKEN||e.type===Tokenizer.WHITESPACE_CHARACTER_TOKEN;return(!(e.type===Tokenizer.START_TAG_TOKEN&&e.tagName!==$.MGLYPH&&e.tagName!==$.MALIGNMARK)&&!o||!this._isIntegrationPoint(n,NS.MATHML))&&((e.type!==Tokenizer.START_TAG_TOKEN&&!o||!this._isIntegrationPoint(n,NS.HTML))&&e.type!==Tokenizer.EOF_TOKEN)}_processToken(e){TOKEN_HANDLERS[this.insertionMode][e.type](this,e)}_processTokenInBodyMode(e){TOKEN_HANDLERS[IN_BODY_MODE][e.type](this,e)}_processTokenInForeignContent(e){e.type===Tokenizer.CHARACTER_TOKEN?characterInForeignContent(this,e):e.type===Tokenizer.NULL_CHARACTER_TOKEN?nullCharacterInForeignContent(this,e):e.type===Tokenizer.WHITESPACE_CHARACTER_TOKEN?insertCharacters(this,e):e.type===Tokenizer.COMMENT_TOKEN?appendComment(this,e):e.type===Tokenizer.START_TAG_TOKEN?startTagInForeignContent(this,e):e.type===Tokenizer.END_TAG_TOKEN&&endTagInForeignContent(this,e)}_processInputToken(e){this._shouldProcessTokenInForeignContent(e)?this._processTokenInForeignContent(e):this._processToken(e),e.type===Tokenizer.START_TAG_TOKEN&&e.selfClosing&&!e.ackSelfClosing&&this._err(ERR.nonVoidHtmlElementStartTagWithTrailingSolidus)}_isIntegrationPoint(e,n){const t=this.treeAdapter.getTagName(e),o=this.treeAdapter.getNamespaceURI(e),T=this.treeAdapter.getAttrList(e);return foreignContent.isIntegrationPoint(t,o,T,n)}_reconstructActiveFormattingElements(){const e=this.activeFormattingElements.length;if(e){let n=e,t=null;do{if(n--,(t=this.activeFormattingElements.entries[n]).type===FormattingElementList.MARKER_ENTRY||this.openElements.contains(t.element)){n++;break}}while(n>0);for(let o=n;o<e;o++)t=this.activeFormattingElements.entries[o],this._insertElement(t.token,this.treeAdapter.getNamespaceURI(t.element)),t.element=this.openElements.current}}_closeTableCell(){this.openElements.generateImpliedEndTags(),this.openElements.popUntilTableCellPopped(),this.activeFormattingElements.clearToLastMarker(),this.insertionMode=IN_ROW_MODE}_closePElement(){this.openElements.generateImpliedEndTagsWithExclusion($.P),this.openElements.popUntilTagNamePopped($.P)}_resetInsertionMode(){for(let e=this.openElements.stackTop,n=!1;e>=0;e--){let t=this.openElements.items[e];0===e&&(n=!0,this.fragmentContext&&(t=this.fragmentContext));const o=this.treeAdapter.getTagName(t),T=INSERTION_MODE_RESET_MAP[o];if(T){this.insertionMode=T;break}if(!(n||o!==$.TD&&o!==$.TH)){this.insertionMode=IN_CELL_MODE;break}if(!n&&o===$.HEAD){this.insertionMode=IN_HEAD_MODE;break}if(o===$.SELECT){this._resetInsertionModeForSelect(e);break}if(o===$.TEMPLATE){this.insertionMode=this.currentTmplInsertionMode;break}if(o===$.HTML){this.insertionMode=this.headElement?AFTER_HEAD_MODE:BEFORE_HEAD_MODE;break}if(n){this.insertionMode=IN_BODY_MODE;break}}}_resetInsertionModeForSelect(e){if(e>0)for(let n=e-1;n>0;n--){const e=this.openElements.items[n],t=this.treeAdapter.getTagName(e);if(t===$.TEMPLATE)break;if(t===$.TABLE)return void(this.insertionMode=IN_SELECT_IN_TABLE_MODE)}this.insertionMode=IN_SELECT_MODE}_pushTmplInsertionMode(e){this.tmplInsertionModeStack.push(e),this.tmplInsertionModeStackTop++,this.currentTmplInsertionMode=e}_popTmplInsertionMode(){this.tmplInsertionModeStack.pop(),this.tmplInsertionModeStackTop--,this.currentTmplInsertionMode=this.tmplInsertionModeStack[this.tmplInsertionModeStackTop]}_isElementCausesFosterParenting(e){const n=this.treeAdapter.getTagName(e);return n===$.TABLE||n===$.TBODY||n===$.TFOOT||n===$.THEAD||n===$.TR}_shouldFosterParentOnInsertion(){return this.fosterParentingEnabled&&this._isElementCausesFosterParenting(this.openElements.current)}_findFosterParentingLocation(){const e={parent:null,beforeElement:null};for(let n=this.openElements.stackTop;n>=0;n--){const t=this.openElements.items[n],o=this.treeAdapter.getTagName(t),T=this.treeAdapter.getNamespaceURI(t);if(o===$.TEMPLATE&&T===NS.HTML){e.parent=this.treeAdapter.getTemplateContent(t);break}if(o===$.TABLE){e.parent=this.treeAdapter.getParentNode(t),e.parent?e.beforeElement=t:e.parent=this.openElements.items[n-1];break}}return e.parent||(e.parent=this.openElements.items[0]),e}_fosterParentElement(e){const n=this._findFosterParentingLocation();n.beforeElement?this.treeAdapter.insertBefore(n.parent,e,n.beforeElement):this.treeAdapter.appendChild(n.parent,e)}_fosterParentText(e){const n=this._findFosterParentingLocation();n.beforeElement?this.treeAdapter.insertTextBefore(n.parent,e,n.beforeElement):this.treeAdapter.insertText(n.parent,e)}_isSpecialElement(e){const n=this.treeAdapter.getTagName(e),t=this.treeAdapter.getNamespaceURI(e);return HTML.SPECIAL_ELEMENTS[t][n]}}function checkselfClosingNode(e,n){const t=(n.tagName||"").toLowerCase(),o=n.selfClosing,T=e.validator.isSupportedSelfClosing(t);if(e.nodeInfo.tn&&t&&!e.nodeInfo.sc){const t=String(n.location.startLine)+String(n.location.startCol);(!T||t!==e.nodeInfo.pos&&n.type===Tokenizer.START_TAG_TOKEN)&&(e.compileResult.log.push({line:String(n.location.startLine)||1,column:String(n.location.startCol)||1,reason:"ERROR: tag `"+e.nodeInfo.tn+"` must be closed, please follow norm"}),e.nodeInfo={})}t&&T&&(n.type!==Tokenizer.START_TAG_TOKEN||o||(e.nodeInfo.tn=t,e.nodeInfo.sc=!1,e.nodeInfo.pos=String(n.location.line)+String(n.location.col)),n.type===Tokenizer.END_TAG_TOKEN&&t===e.nodeInfo.tn&&(e.nodeInfo.sc=!0)),!T&&o&&n.type===Tokenizer.START_TAG_TOKEN&&e.compileResult.log.push({line:n.location.startLine||1,column:n.location.startCol||1,reason:"ERROR: tag `"+t+"` can not use selfClosing"})}function checkInvalid(e){e.type&&e.type!==Tokenizer.END_TAG_TOKEN&&e.type!==Tokenizer.COMMENT_TOKEN&&compileResult.log.push({line:e.location.startLine||1,column:e.location.startCol||1,reason:"ERROR: hml content is invalid. Please check it."})}function aaObtainFormattingElementEntry(e,n){let t=e.activeFormattingElements.getElementEntryInScopeWithTagName(n.tagName);return t?e.openElements.contains(t.element)?e.openElements.hasInScope(n.tagName)||(t=null):(e.activeFormattingElements.removeEntry(t),t=null):genericEndTagInBody(e,n),t}function aaObtainFurthestBlock(e,n){let t=null;for(let o=e.openElements.stackTop;o>=0;o--){const T=e.openElements.items[o];if(T===n.element)break;e._isSpecialElement(T)&&(t=T)}return t||(e.openElements.popUntilElementPopped(n.element),e.activeFormattingElements.removeEntry(n)),t}function aaInnerLoop(e,n,t){let o=n,T=e.openElements.getCommonAncestor(n);for(let r=0,a=T;a!==t;r++,a=T){T=e.openElements.getCommonAncestor(a);const t=e.activeFormattingElements.getElementEntry(a),E=t&&r>=AA_INNER_LOOP_ITER;!t||E?(E&&e.activeFormattingElements.removeEntry(t),e.openElements.remove(a)):(a=aaRecreateElementFromEntry(e,t),o===n&&(e.activeFormattingElements.bookmark=t),e.treeAdapter.detachNode(o),e.treeAdapter.appendChild(a,o),o=a)}return o}function aaRecreateElementFromEntry(e,n){const t=e.treeAdapter.getNamespaceURI(n.element),o=e.treeAdapter.createElement(n.token.tagName,t,n.token.attrs);return e.openElements.replace(n.element,o),n.element=o,o}function aaInsertLastNodeInCommonAncestor(e,n,t){if(e._isElementCausesFosterParenting(n))e._fosterParentElement(t);else{const o=e.treeAdapter.getTagName(n),T=e.treeAdapter.getNamespaceURI(n);o===$.TEMPLATE&&T===NS.HTML&&(n=e.treeAdapter.getTemplateContent(n)),e.treeAdapter.appendChild(n,t)}}function aaReplaceFormattingElement(e,n,t){const o=e.treeAdapter.getNamespaceURI(t.element),T=t.token,r=e.treeAdapter.createElement(T.tagName,o,T.attrs);e._adoptNodes(n,r),e.treeAdapter.appendChild(n,r),e.activeFormattingElements.insertElementAfterBookmark(r,t.token),e.activeFormattingElements.removeEntry(t),e.openElements.remove(t.element),e.openElements.insertAfter(n,r)}function callAdoptionAgency(e,n){let t;for(let o=0;o<AA_OUTER_LOOP_ITER&&(t=aaObtainFormattingElementEntry(e,n,t));o++){const n=aaObtainFurthestBlock(e,t);if(!n)break;e.activeFormattingElements.bookmark=t;const o=aaInnerLoop(e,n,t.element),T=e.openElements.getCommonAncestor(t.element);e.treeAdapter.detachNode(o),aaInsertLastNodeInCommonAncestor(e,T,o),aaReplaceFormattingElement(e,n,t)}}function ignoreToken(){}function misplacedDoctype(e){e._err(ERR.misplacedDoctype)}function appendComment(e,n){e._appendCommentNode(n,e.openElements.currentTmplContent||e.openElements.current)}function appendCommentToRootHtmlElement(e,n){e._appendCommentNode(n,e.openElements.items[0])}function appendCommentToDocument(e,n){e._appendCommentNode(n,e.document)}function insertCharacters(e,n){e._insertCharacters(n)}function stopParsing(e){e.stopped=!0}function doctypeInInitialMode(e,n){e._setDocumentType(n);const t=n.forceQuirks?HTML.DOCUMENT_MODE.QUIRKS:doctype.getDocumentMode(n);doctype.isConforming(n)||e._err(ERR.nonConformingDoctype),e.treeAdapter.setDocumentMode(e.document,t),e.insertionMode=BEFORE_HTML_MODE}function tokenInInitialMode(e,n){e._err(ERR.missingDoctype,{beforeToken:!0}),e.treeAdapter.setDocumentMode(e.document,HTML.DOCUMENT_MODE.QUIRKS),e.insertionMode=BEFORE_HTML_MODE,e._processToken(n)}function startTagBeforeHtml(e,n){n.tagName===$.HTML?(e._insertElement(n,NS.HTML),e.insertionMode=BEFORE_HEAD_MODE):tokenBeforeHtml(e,n)}function endTagBeforeHtml(e,n){const t=n.tagName;t!==$.HTML&&t!==$.HEAD&&t!==$.BODY&&t!==$.BR||tokenBeforeHtml(e,n)}function tokenBeforeHtml(e,n){e._insertFakeRootElement(),e.insertionMode=BEFORE_HEAD_MODE,e._processToken(n)}function startTagBeforeHead(e,n){const t=n.tagName;t===$.HTML?startTagInBody(e,n):t===$.HEAD?(e._insertElement(n,NS.HTML),e.headElement=e.openElements.current,e.insertionMode=IN_HEAD_MODE):tokenBeforeHead(e,n)}function endTagBeforeHead(e,n){const t=n.tagName;t===$.HEAD||t===$.BODY||t===$.HTML||t===$.BR?tokenBeforeHead(e,n):e._err(ERR.endTagWithoutMatchingOpenElement)}function tokenBeforeHead(e,n){e._insertFakeElement($.HEAD),e.headElement=e.openElements.current,e.insertionMode=IN_HEAD_MODE,e._processToken(n)}function startTagInHead(e,n){const t=n.tagName;t===$.HTML?startTagInBody(e,n):t===$.BASE||t===$.BASEFONT||t===$.BGSOUND||t===$.LINK||t===$.META?(e._appendElement(n,NS.HTML),n.ackSelfClosing=!0):t===$.TITLE?e._switchToTextParsing(n,Tokenizer.MODE.RCDATA):t===$.NOSCRIPT?e.options.scriptingEnabled?e._switchToTextParsing(n,Tokenizer.MODE.RAWTEXT):(e._insertElement(n,NS.HTML),e.insertionMode=IN_HEAD_NO_SCRIPT_MODE):t===$.NOFRAMES||t===$.STYLE?e._switchToTextParsing(n,Tokenizer.MODE.RAWTEXT):t===$.SCRIPT?e._switchToTextParsing(n,Tokenizer.MODE.SCRIPT_DATA):t===$.TEMPLATE?(e._insertTemplate(n,NS.HTML),e.activeFormattingElements.insertMarker(),e.framesetOk=!1,e.insertionMode=IN_TEMPLATE_MODE,e._pushTmplInsertionMode(IN_TEMPLATE_MODE)):t===$.HEAD?e._err(ERR.misplacedStartTagForHeadElement):tokenInHead(e,n)}function endTagInHead(e,n){const t=n.tagName;t===$.HEAD?(e.openElements.pop(),e.insertionMode=AFTER_HEAD_MODE):t===$.BODY||t===$.BR||t===$.HTML?tokenInHead(e,n):t===$.TEMPLATE&&e.openElements.tmplCount>0?(e.openElements.generateImpliedEndTagsThoroughly(),e.openElements.currentTagName!==$.TEMPLATE&&e._err(ERR.closingOfElementWithOpenChildElements),e.openElements.popUntilTagNamePopped($.TEMPLATE),e.activeFormattingElements.clearToLastMarker(),e._popTmplInsertionMode(),e._resetInsertionMode()):e._err(ERR.endTagWithoutMatchingOpenElement)}function tokenInHead(e,n){e.openElements.pop(),e.insertionMode=AFTER_HEAD_MODE,e._processToken(n)}function startTagInHeadNoScript(e,n){const t=n.tagName;t===$.HTML?startTagInBody(e,n):t===$.BASEFONT||t===$.BGSOUND||t===$.HEAD||t===$.LINK||t===$.META||t===$.NOFRAMES||t===$.STYLE?startTagInHead(e,n):t===$.NOSCRIPT?e._err(ERR.nestedNoscriptInHead):tokenInHeadNoScript(e,n)}function endTagInHeadNoScript(e,n){const t=n.tagName;t===$.NOSCRIPT?(e.openElements.pop(),e.insertionMode=IN_HEAD_MODE):t===$.BR?tokenInHeadNoScript(e,n):e._err(ERR.endTagWithoutMatchingOpenElement)}function tokenInHeadNoScript(e,n){const t=n.type===Tokenizer.EOF_TOKEN?ERR.openElementsLeftAfterEof:ERR.disallowedContentInNoscriptInHead;e._err(t),e.openElements.pop(),e.insertionMode=IN_HEAD_MODE,e._processToken(n)}function startTagAfterHead(e,n){const t=n.tagName;t===$.HTML?startTagInBody(e,n):t===$.BODY?(e._insertElement(n,NS.HTML),e.framesetOk=!1,e.insertionMode=IN_BODY_MODE):t===$.FRAMESET?(e._insertElement(n,NS.HTML),e.insertionMode=IN_FRAMESET_MODE):t===$.BASE||t===$.BASEFONT||t===$.BGSOUND||t===$.LINK||t===$.META||t===$.NOFRAMES||t===$.SCRIPT||t===$.STYLE||t===$.TEMPLATE||t===$.TITLE?(e._err(ERR.abandonedHeadElementChild),e.openElements.push(e.headElement),startTagInHead(e,n),e.openElements.remove(e.headElement)):t===$.HEAD?e._err(ERR.misplacedStartTagForHeadElement):tokenAfterHead(e,n)}function endTagAfterHead(e,n){const t=n.tagName;t===$.BODY||t===$.HTML||t===$.BR?tokenAfterHead(e,n):t===$.TEMPLATE?endTagInHead(e,n):e._err(ERR.endTagWithoutMatchingOpenElement)}function tokenAfterHead(e,n){e._insertFakeElement($.BODY),e.insertionMode=IN_BODY_MODE,e._processToken(n)}function whitespaceCharacterInBody(e,n){e._reconstructActiveFormattingElements(),e._insertCharacters(n)}function characterInBody(e,n){e._reconstructActiveFormattingElements(),e._insertCharacters(n),e.framesetOk=!1}function htmlStartTagInBody(e,n){0===e.openElements.tmplCount&&e.treeAdapter.adoptAttributes(e.openElements.items[0],n.attrs)}function bodyStartTagInBody(e,n){const t=e.openElements.tryPeekProperlyNestedBodyElement();t&&0===e.openElements.tmplCount&&(e.framesetOk=!1,e.treeAdapter.adoptAttributes(t,n.attrs))}function framesetStartTagInBody(e,n){const t=e.openElements.tryPeekProperlyNestedBodyElement();e.framesetOk&&t&&(e.treeAdapter.detachNode(t),e.openElements.popAllUpToHtmlElement(),e._insertElement(n,NS.HTML),e.insertionMode=IN_FRAMESET_MODE)}function addressStartTagInBody(e,n){e.openElements.hasInButtonScope($.P)&&e._closePElement(),e._insertElement(n,NS.HTML)}function numberedHeaderStartTagInBody(e,n){e.openElements.hasInButtonScope($.P)&&e._closePElement();const t=e.openElements.currentTagName;t!==$.H1&&t!==$.H2&&t!==$.H3&&t!==$.H4&&t!==$.H5&&t!==$.H6||e.openElements.pop(),e._insertElement(n,NS.HTML)}function preStartTagInBody(e,n){e.openElements.hasInButtonScope($.P)&&e._closePElement(),e._insertElement(n,NS.HTML),e.skipNextNewLine=!0,e.framesetOk=!1}function formStartTagInBody(e,n){const t=e.openElements.tmplCount>0;e.formElement&&!t||(e.openElements.hasInButtonScope($.P)&&e._closePElement(),e._insertElement(n,NS.HTML),t||(e.formElement=e.openElements.current))}function listItemStartTagInBody(e,n){e.framesetOk=!1;const t=n.tagName;for(let n=e.openElements.stackTop;n>=0;n--){const o=e.openElements.items[n],T=e.treeAdapter.getTagName(o);let r=null;if(t===$.LI&&T===$.LI?r=$.LI:t!==$.DD&&t!==$.DT||T!==$.DD&&T!==$.DT||(r=T),r){e.openElements.generateImpliedEndTagsWithExclusion(r),e.openElements.popUntilTagNamePopped(r);break}if(T!==$.ADDRESS&&T!==$.DIV&&T!==$.P&&e._isSpecialElement(o))break}e.openElements.hasInButtonScope($.P)&&e._closePElement(),e._insertElement(n,NS.HTML)}function plaintextStartTagInBody(e,n){e.openElements.hasInButtonScope($.P)&&e._closePElement(),e._insertElement(n,NS.HTML),e.tokenizer.state=Tokenizer.MODE.PLAINTEXT}function buttonStartTagInBody(e,n){e.openElements.hasInScope($.BUTTON)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped($.BUTTON)),e._reconstructActiveFormattingElements(),e._insertElement(n,NS.HTML),e.framesetOk=!1}function aStartTagInBody(e,n){const t=e.activeFormattingElements.getElementEntryInScopeWithTagName($.A);t&&(callAdoptionAgency(e,n),e.openElements.remove(t.element),e.activeFormattingElements.removeEntry(t)),e._reconstructActiveFormattingElements(),e._insertElement(n,NS.HTML),e.activeFormattingElements.pushElement(e.openElements.current,n)}function bStartTagInBody(e,n){e._reconstructActiveFormattingElements(),e._insertElement(n,NS.HTML),e.activeFormattingElements.pushElement(e.openElements.current,n)}function nobrStartTagInBody(e,n){e._reconstructActiveFormattingElements(),e.openElements.hasInScope($.NOBR)&&(callAdoptionAgency(e,n),e._reconstructActiveFormattingElements()),e._insertElement(n,NS.HTML),e.activeFormattingElements.pushElement(e.openElements.current,n)}function appletStartTagInBody(e,n){e._reconstructActiveFormattingElements(),e._insertElement(n,NS.HTML),e.activeFormattingElements.insertMarker(),e.framesetOk=!1}function tableStartTagInBody(e,n){e.treeAdapter.getDocumentMode(e.document)!==HTML.DOCUMENT_MODE.QUIRKS&&e.openElements.hasInButtonScope($.P)&&e._closePElement(),e._insertElement(n,NS.HTML),e.framesetOk=!1,e.insertionMode=IN_TABLE_MODE}function areaStartTagInBody(e,n){e._reconstructActiveFormattingElements(),e._appendElement(n,NS.HTML),e.framesetOk=!1,n.ackSelfClosing=!0}function inputStartTagInBody(e,n){e._reconstructActiveFormattingElements(),e._appendElement(n,NS.HTML);const t=Tokenizer.getTokenAttr(n,ATTRS.TYPE);t&&t.toLowerCase()===HIDDEN_INPUT_TYPE||(e.framesetOk=!1),n.ackSelfClosing=!0}function paramStartTagInBody(e,n){e._appendElement(n,NS.HTML),n.ackSelfClosing=!0}function hrStartTagInBody(e,n){e.openElements.hasInButtonScope($.P)&&e._closePElement(),e._appendElement(n,NS.HTML),e.framesetOk=!1,e.ackSelfClosing=!0}function imageStartTagInBody(e,n){n.tagName=$.IMG,areaStartTagInBody(e,n)}function textareaStartTagInBody(e,n){e._insertElement(n,NS.HTML),e.skipNextNewLine=!0,e.tokenizer.state=Tokenizer.MODE.RCDATA,e.originalInsertionMode=e.insertionMode,e.framesetOk=!1,e.insertionMode=TEXT_MODE}function xmpStartTagInBody(e,n){e.openElements.hasInButtonScope($.P)&&e._closePElement(),e._reconstructActiveFormattingElements(),e.framesetOk=!1,e._switchToTextParsing(n,Tokenizer.MODE.RAWTEXT)}function iframeStartTagInBody(e,n){e.framesetOk=!1,e._switchToTextParsing(n,Tokenizer.MODE.RAWTEXT)}function noembedStartTagInBody(e,n){e._switchToTextParsing(n,Tokenizer.MODE.RAWTEXT)}function selectStartTagInBody(e,n){e._reconstructActiveFormattingElements(),e._insertElement(n,NS.HTML),e.framesetOk=!1,e.insertionMode===IN_TABLE_MODE||e.insertionMode===IN_CAPTION_MODE||e.insertionMode===IN_TABLE_BODY_MODE||e.insertionMode===IN_ROW_MODE||e.insertionMode===IN_CELL_MODE?e.insertionMode=IN_SELECT_IN_TABLE_MODE:e.insertionMode=IN_SELECT_MODE}function optgroupStartTagInBody(e,n){e.openElements.currentTagName===$.OPTION&&e.openElements.pop(),e._reconstructActiveFormattingElements(),e._insertElement(n,NS.HTML)}function rbStartTagInBody(e,n){e.openElements.hasInScope($.RUBY)&&e.openElements.generateImpliedEndTags(),e._insertElement(n,NS.HTML)}function rtStartTagInBody(e,n){e.openElements.hasInScope($.RUBY)&&e.openElements.generateImpliedEndTagsWithExclusion($.RTC),e._insertElement(n,NS.HTML)}function menuStartTagInBody(e,n){e.openElements.hasInButtonScope($.P)&&e._closePElement(),e._insertElement(n,NS.HTML)}function mathStartTagInBody(e,n){e._reconstructActiveFormattingElements(),foreignContent.adjustTokenMathMLAttrs(n),foreignContent.adjustTokenXMLAttrs(n),n.selfClosing?e._appendElement(n,NS.MATHML):e._insertElement(n,NS.MATHML),n.ackSelfClosing=!0}function svgStartTagInBody(e,n){e._reconstructActiveFormattingElements(),foreignContent.adjustTokenSVGAttrs(n),foreignContent.adjustTokenXMLAttrs(n),n.selfClosing?e._appendElement(n,NS.SVG):e._insertElement(n,NS.SVG),n.ackSelfClosing=!0}function genericStartTagInBody(e,n){e._reconstructActiveFormattingElements(),e._insertElement(n,NS.HTML)}function startTagInBody(e,n){const t=n.tagName;switch(t.length){case 1:t===$.I||t===$.S||t===$.B||t===$.U?bStartTagInBody(e,n):t===$.P?addressStartTagInBody(e,n):t===$.A?aStartTagInBody(e,n):genericStartTagInBody(e,n);break;case 2:t===$.DL||t===$.OL||t===$.UL?addressStartTagInBody(e,n):t===$.H1||t===$.H2||t===$.H3||t===$.H4||t===$.H5||t===$.H6?numberedHeaderStartTagInBody(e,n):t===$.LI||t===$.DD||t===$.DT?listItemStartTagInBody(e,n):t===$.EM||t===$.TT?bStartTagInBody(e,n):t===$.BR?areaStartTagInBody(e,n):t===$.HR?hrStartTagInBody(e,n):t===$.RB?rbStartTagInBody(e,n):t===$.RT||t===$.RP?rtStartTagInBody(e,n):t!==$.TH&&t!==$.TD&&t!==$.TR&&genericStartTagInBody(e,n);break;case 3:t===$.DIV||t===$.DIR||t===$.NAV?addressStartTagInBody(e,n):t===$.PRE?preStartTagInBody(e,n):t===$.BIG?bStartTagInBody(e,n):t===$.IMG||t===$.WBR?areaStartTagInBody(e,n):t===$.XMP?xmpStartTagInBody(e,n):t===$.SVG?svgStartTagInBody(e,n):t===$.RTC?rbStartTagInBody(e,n):t!==$.COL&&genericStartTagInBody(e,n);break;case 4:t===$.HTML?htmlStartTagInBody(e,n):t===$.BASE||t===$.LINK||t===$.META?startTagInHead(e,n):t===$.BODY?bodyStartTagInBody(e,n):t===$.MAIN||t===$.MENU?addressStartTagInBody(e,n):t===$.FORM?formStartTagInBody(e,n):t===$.CODE||t===$.FONT?bStartTagInBody(e,n):t===$.NOBR?nobrStartTagInBody(e,n):t===$.AREA?areaStartTagInBody(e,n):t===$.MATH?mathStartTagInBody(e,n):t===$.MENU?menuStartTagInBody(e,n):t!==$.HEAD&&genericStartTagInBody(e,n);break;case 5:t===$.STYLE||t===$.TITLE?startTagInHead(e,n):t===$.ASIDE?addressStartTagInBody(e,n):t===$.SMALL?bStartTagInBody(e,n):t===$.TABLE?tableStartTagInBody(e,n):t===$.EMBED?areaStartTagInBody(e,n):t===$.INPUT?inputStartTagInBody(e,n):t===$.PARAM||t===$.TRACK?paramStartTagInBody(e,n):t===$.IMAGE?imageStartTagInBody(e,n):t!==$.FRAME&&t!==$.TBODY&&t!==$.TFOOT&&t!==$.THEAD&&genericStartTagInBody(e,n);break;case 6:t===$.SCRIPT?startTagInHead(e,n):t===$.CENTER||t===$.FIGURE||t===$.FOOTER||t===$.HEADER||t===$.HGROUP||t===$.DIALOG?addressStartTagInBody(e,n):t===$.BUTTON?buttonStartTagInBody(e,n):t===$.STRIKE||t===$.STRONG?bStartTagInBody(e,n):t===$.APPLET||t===$.OBJECT?appletStartTagInBody(e,n):t===$.KEYGEN?areaStartTagInBody(e,n):t===$.SOURCE?paramStartTagInBody(e,n):t===$.IFRAME?iframeStartTagInBody(e,n):t===$.SELECT?selectStartTagInBody(e,n):t===$.OPTION?optgroupStartTagInBody(e,n):genericStartTagInBody(e,n);break;case 7:t===$.BGSOUND?startTagInHead(e,n):t===$.DETAILS||t===$.ADDRESS||t===$.ARTICLE||t===$.SECTION||t===$.SUMMARY?addressStartTagInBody(e,n):t===$.LISTING?preStartTagInBody(e,n):t===$.MARQUEE?appletStartTagInBody(e,n):t===$.NOEMBED?noembedStartTagInBody(e,n):t!==$.CAPTION&&genericStartTagInBody(e,n);break;case 8:t===$.BASEFONT?startTagInHead(e,n):t===$.FRAMESET?framesetStartTagInBody(e,n):t===$.FIELDSET?addressStartTagInBody(e,n):t===$.TEXTAREA?textareaStartTagInBody(e,n):t===$.TEMPLATE?startTagInHead(e,n):t===$.NOSCRIPT?e.options.scriptingEnabled?noembedStartTagInBody(e,n):genericStartTagInBody(e,n):t===$.OPTGROUP?optgroupStartTagInBody(e,n):t!==$.COLGROUP&&genericStartTagInBody(e,n);break;case 9:t===$.PLAINTEXT?plaintextStartTagInBody(e,n):genericStartTagInBody(e,n);break;case 10:t===$.BLOCKQUOTE||t===$.FIGCAPTION?addressStartTagInBody(e,n):genericStartTagInBody(e,n);break;default:genericStartTagInBody(e,n)}}function bodyEndTagInBody(e){e.openElements.hasInScope($.BODY)&&(e.insertionMode=AFTER_BODY_MODE)}function htmlEndTagInBody(e,n){e.openElements.hasInScope($.BODY)&&(e.insertionMode=AFTER_BODY_MODE,e._processToken(n))}function addressEndTagInBody(e,n){const t=n.tagName;e.openElements.hasInScope(t)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped(t))}function formEndTagInBody(e){const n=e.openElements.tmplCount>0,t=e.formElement;n||(e.formElement=null),(t||n)&&e.openElements.hasInScope($.FORM)&&(e.openElements.generateImpliedEndTags(),n?e.openElements.popUntilTagNamePopped($.FORM):e.openElements.remove(t))}function pEndTagInBody(e){e.openElements.hasInButtonScope($.P)||e._insertFakeElement($.P),e._closePElement()}function liEndTagInBody(e){e.openElements.hasInListItemScope($.LI)&&(e.openElements.generateImpliedEndTagsWithExclusion($.LI),e.openElements.popUntilTagNamePopped($.LI))}function ddEndTagInBody(e,n){const t=n.tagName;e.openElements.hasInScope(t)&&(e.openElements.generateImpliedEndTagsWithExclusion(t),e.openElements.popUntilTagNamePopped(t))}function numberedHeaderEndTagInBody(e){e.openElements.hasNumberedHeaderInScope()&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilNumberedHeaderPopped())}function appletEndTagInBody(e,n){const t=n.tagName;e.openElements.hasInScope(t)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped(t),e.activeFormattingElements.clearToLastMarker())}function brEndTagInBody(e){e._reconstructActiveFormattingElements(),e._insertFakeElement($.BR),e.openElements.pop(),e.framesetOk=!1}function genericEndTagInBody(e,n){const t=n.tagName;for(let n=e.openElements.stackTop;n>0;n--){const o=e.openElements.items[n];if(e.treeAdapter.getTagName(o)===t){e.openElements.generateImpliedEndTagsWithExclusion(t),e.openElements.popUntilElementPopped(o);break}if(e._isSpecialElement(o))break}}function endTagInBody(e,n){const t=n.tagName;switch(t.length){case 1:t===$.A||t===$.B||t===$.I||t===$.S||t===$.U?callAdoptionAgency(e,n):t===$.P?pEndTagInBody(e,n):genericEndTagInBody(e,n);break;case 2:t===$.DL||t===$.UL||t===$.OL?addressEndTagInBody(e,n):t===$.LI?liEndTagInBody(e,n):t===$.DD||t===$.DT?ddEndTagInBody(e,n):t===$.H1||t===$.H2||t===$.H3||t===$.H4||t===$.H5||t===$.H6?numberedHeaderEndTagInBody(e,n):t===$.BR?brEndTagInBody(e,n):t===$.EM||t===$.TT?callAdoptionAgency(e,n):genericEndTagInBody(e,n);break;case 3:t===$.BIG?callAdoptionAgency(e,n):t===$.DIR||t===$.DIV||t===$.NAV||t===$.PRE?addressEndTagInBody(e,n):genericEndTagInBody(e,n);break;case 4:t===$.BODY?bodyEndTagInBody(e,n):t===$.HTML?htmlEndTagInBody(e,n):t===$.FORM?formEndTagInBody(e,n):t===$.CODE||t===$.FONT||t===$.NOBR?callAdoptionAgency(e,n):t===$.MAIN||t===$.MENU?addressEndTagInBody(e,n):genericEndTagInBody(e,n);break;case 5:t===$.ASIDE?addressEndTagInBody(e,n):t===$.SMALL?callAdoptionAgency(e,n):genericEndTagInBody(e,n);break;case 6:t===$.CENTER||t===$.FIGURE||t===$.FOOTER||t===$.HEADER||t===$.HGROUP||t===$.DIALOG?addressEndTagInBody(e,n):t===$.APPLET||t===$.OBJECT?appletEndTagInBody(e,n):t===$.STRIKE||t===$.STRONG?callAdoptionAgency(e,n):genericEndTagInBody(e,n);break;case 7:t===$.ADDRESS||t===$.ARTICLE||t===$.DETAILS||t===$.SECTION||t===$.SUMMARY||t===$.LISTING?addressEndTagInBody(e,n):t===$.MARQUEE?appletEndTagInBody(e,n):genericEndTagInBody(e,n);break;case 8:t===$.FIELDSET?addressEndTagInBody(e,n):t===$.TEMPLATE?endTagInHead(e,n):genericEndTagInBody(e,n);break;case 10:t===$.BLOCKQUOTE||t===$.FIGCAPTION?addressEndTagInBody(e,n):genericEndTagInBody(e,n);break;default:genericEndTagInBody(e,n)}}function eofInBody(e,n){e.tmplInsertionModeStackTop>-1?eofInTemplate(e,n):e.stopped=!0}function endTagInText(e,n){n.tagName===$.SCRIPT&&(e.pendingScript=e.openElements.current),e.openElements.pop(),e.insertionMode=e.originalInsertionMode}function eofInText(e,n){e._err(ERR.eofInElementThatCanContainOnlyText),e.openElements.pop(),e.insertionMode=e.originalInsertionMode,e._processToken(n)}function characterInTable(e,n){const t=e.openElements.currentTagName;t===$.TABLE||t===$.TBODY||t===$.TFOOT||t===$.THEAD||t===$.TR?(e.pendingCharacterTokens=[],e.hasNonWhitespacePendingCharacterToken=!1,e.originalInsertionMode=e.insertionMode,e.insertionMode=IN_TABLE_TEXT_MODE,e._processToken(n)):tokenInTable(e,n)}function captionStartTagInTable(e,n){e.openElements.clearBackToTableContext(),e.activeFormattingElements.insertMarker(),e._insertElement(n,NS.HTML),e.insertionMode=IN_CAPTION_MODE}function colgroupStartTagInTable(e,n){e.openElements.clearBackToTableContext(),e._insertElement(n,NS.HTML),e.insertionMode=IN_COLUMN_GROUP_MODE}function colStartTagInTable(e,n){e.openElements.clearBackToTableContext(),e._insertFakeElement($.COLGROUP),e.insertionMode=IN_COLUMN_GROUP_MODE,e._processToken(n)}function tbodyStartTagInTable(e,n){e.openElements.clearBackToTableContext(),e._insertElement(n,NS.HTML),e.insertionMode=IN_TABLE_BODY_MODE}function tdStartTagInTable(e,n){e.openElements.clearBackToTableContext(),e._insertFakeElement($.TBODY),e.insertionMode=IN_TABLE_BODY_MODE,e._processToken(n)}function tableStartTagInTable(e,n){e.openElements.hasInTableScope($.TABLE)&&(e.openElements.popUntilTagNamePopped($.TABLE),e._resetInsertionMode(),e._processToken(n))}function inputStartTagInTable(e,n){const t=Tokenizer.getTokenAttr(n,ATTRS.TYPE);t&&t.toLowerCase()===HIDDEN_INPUT_TYPE?e._appendElement(n,NS.HTML):tokenInTable(e,n),n.ackSelfClosing=!0}function formStartTagInTable(e,n){e.formElement||0!==e.openElements.tmplCount||(e._insertElement(n,NS.HTML),e.formElement=e.openElements.current,e.openElements.pop())}function startTagInTable(e,n){const t=n.tagName;switch(t.length){case 2:t===$.TD||t===$.TH||t===$.TR?tdStartTagInTable(e,n):tokenInTable(e,n);break;case 3:t===$.COL?colStartTagInTable(e,n):tokenInTable(e,n);break;case 4:t===$.FORM?formStartTagInTable(e,n):tokenInTable(e,n);break;case 5:t===$.TABLE?tableStartTagInTable(e,n):t===$.STYLE?startTagInHead(e,n):t===$.TBODY||t===$.TFOOT||t===$.THEAD?tbodyStartTagInTable(e,n):t===$.INPUT?inputStartTagInTable(e,n):tokenInTable(e,n);break;case 6:t===$.SCRIPT?startTagInHead(e,n):tokenInTable(e,n);break;case 7:t===$.CAPTION?captionStartTagInTable(e,n):tokenInTable(e,n);break;case 8:t===$.COLGROUP?colgroupStartTagInTable(e,n):t===$.TEMPLATE?startTagInHead(e,n):tokenInTable(e,n);break;default:tokenInTable(e,n)}}function endTagInTable(e,n){const t=n.tagName;t===$.TABLE?e.openElements.hasInTableScope($.TABLE)&&(e.openElements.popUntilTagNamePopped($.TABLE),e._resetInsertionMode()):t===$.TEMPLATE?endTagInHead(e,n):t!==$.BODY&&t!==$.CAPTION&&t!==$.COL&&t!==$.COLGROUP&&t!==$.HTML&&t!==$.TBODY&&t!==$.TD&&t!==$.TFOOT&&t!==$.TH&&t!==$.THEAD&&t!==$.TR&&tokenInTable(e,n)}function tokenInTable(e,n){const t=e.fosterParentingEnabled;e.fosterParentingEnabled=!0,e._processTokenInBodyMode(n),e.fosterParentingEnabled=t}function whitespaceCharacterInTableText(e,n){e.pendingCharacterTokens.push(n)}function characterInTableText(e,n){e.pendingCharacterTokens.push(n),e.hasNonWhitespacePendingCharacterToken=!0}function tokenInTableText(e,n){let t=0;if(e.hasNonWhitespacePendingCharacterToken)for(;t<e.pendingCharacterTokens.length;t++)tokenInTable(e,e.pendingCharacterTokens[t]);else for(;t<e.pendingCharacterTokens.length;t++)e._insertCharacters(e.pendingCharacterTokens[t]);e.insertionMode=e.originalInsertionMode,e._processToken(n)}function startTagInCaption(e,n){const t=n.tagName;t===$.CAPTION||t===$.COL||t===$.COLGROUP||t===$.TBODY||t===$.TD||t===$.TFOOT||t===$.TH||t===$.THEAD||t===$.TR?e.openElements.hasInTableScope($.CAPTION)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped($.CAPTION),e.activeFormattingElements.clearToLastMarker(),e.insertionMode=IN_TABLE_MODE,e._processToken(n)):startTagInBody(e,n)}function endTagInCaption(e,n){const t=n.tagName;t===$.CAPTION||t===$.TABLE?e.openElements.hasInTableScope($.CAPTION)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped($.CAPTION),e.activeFormattingElements.clearToLastMarker(),e.insertionMode=IN_TABLE_MODE,t===$.TABLE&&e._processToken(n)):t!==$.BODY&&t!==$.COL&&t!==$.COLGROUP&&t!==$.HTML&&t!==$.TBODY&&t!==$.TD&&t!==$.TFOOT&&t!==$.TH&&t!==$.THEAD&&t!==$.TR&&endTagInBody(e,n)}function startTagInColumnGroup(e,n){const t=n.tagName;t===$.HTML?startTagInBody(e,n):t===$.COL?(e._appendElement(n,NS.HTML),n.ackSelfClosing=!0):t===$.TEMPLATE?startTagInHead(e,n):tokenInColumnGroup(e,n)}function endTagInColumnGroup(e,n){const t=n.tagName;t===$.COLGROUP?e.openElements.currentTagName===$.COLGROUP&&(e.openElements.pop(),e.insertionMode=IN_TABLE_MODE):t===$.TEMPLATE?endTagInHead(e,n):t!==$.COL&&tokenInColumnGroup(e,n)}function tokenInColumnGroup(e,n){e.openElements.currentTagName===$.COLGROUP&&(e.openElements.pop(),e.insertionMode=IN_TABLE_MODE,e._processToken(n))}function startTagInTableBody(e,n){const t=n.tagName;t===$.TR?(e.openElements.clearBackToTableBodyContext(),e._insertElement(n,NS.HTML),e.insertionMode=IN_ROW_MODE):t===$.TH||t===$.TD?(e.openElements.clearBackToTableBodyContext(),e._insertFakeElement($.TR),e.insertionMode=IN_ROW_MODE,e._processToken(n)):t===$.CAPTION||t===$.COL||t===$.COLGROUP||t===$.TBODY||t===$.TFOOT||t===$.THEAD?e.openElements.hasTableBodyContextInTableScope()&&(e.openElements.clearBackToTableBodyContext(),e.openElements.pop(),e.insertionMode=IN_TABLE_MODE,e._processToken(n)):startTagInTable(e,n)}function endTagInTableBody(e,n){const t=n.tagName;t===$.TBODY||t===$.TFOOT||t===$.THEAD?e.openElements.hasInTableScope(t)&&(e.openElements.clearBackToTableBodyContext(),e.openElements.pop(),e.insertionMode=IN_TABLE_MODE):t===$.TABLE?e.openElements.hasTableBodyContextInTableScope()&&(e.openElements.clearBackToTableBodyContext(),e.openElements.pop(),e.insertionMode=IN_TABLE_MODE,e._processToken(n)):(t!==$.BODY&&t!==$.CAPTION&&t!==$.COL&&t!==$.COLGROUP||t!==$.HTML&&t!==$.TD&&t!==$.TH&&t!==$.TR)&&endTagInTable(e,n)}function startTagInRow(e,n){const t=n.tagName;t===$.TH||t===$.TD?(e.openElements.clearBackToTableRowContext(),e._insertElement(n,NS.HTML),e.insertionMode=IN_CELL_MODE,e.activeFormattingElements.insertMarker()):t===$.CAPTION||t===$.COL||t===$.COLGROUP||t===$.TBODY||t===$.TFOOT||t===$.THEAD||t===$.TR?e.openElements.hasInTableScope($.TR)&&(e.openElements.clearBackToTableRowContext(),e.openElements.pop(),e.insertionMode=IN_TABLE_BODY_MODE,e._processToken(n)):startTagInTable(e,n)}function endTagInRow(e,n){const t=n.tagName;t===$.TR?e.openElements.hasInTableScope($.TR)&&(e.openElements.clearBackToTableRowContext(),e.openElements.pop(),e.insertionMode=IN_TABLE_BODY_MODE):t===$.TABLE?e.openElements.hasInTableScope($.TR)&&(e.openElements.clearBackToTableRowContext(),e.openElements.pop(),e.insertionMode=IN_TABLE_BODY_MODE,e._processToken(n)):t===$.TBODY||t===$.TFOOT||t===$.THEAD?(e.openElements.hasInTableScope(t)||e.openElements.hasInTableScope($.TR))&&(e.openElements.clearBackToTableRowContext(),e.openElements.pop(),e.insertionMode=IN_TABLE_BODY_MODE,e._processToken(n)):(t!==$.BODY&&t!==$.CAPTION&&t!==$.COL&&t!==$.COLGROUP||t!==$.HTML&&t!==$.TD&&t!==$.TH)&&endTagInTable(e,n)}function startTagInCell(e,n){const t=n.tagName;t===$.CAPTION||t===$.COL||t===$.COLGROUP||t===$.TBODY||t===$.TD||t===$.TFOOT||t===$.TH||t===$.THEAD||t===$.TR?(e.openElements.hasInTableScope($.TD)||e.openElements.hasInTableScope($.TH))&&(e._closeTableCell(),e._processToken(n)):startTagInBody(e,n)}function endTagInCell(e,n){const t=n.tagName;t===$.TD||t===$.TH?e.openElements.hasInTableScope(t)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped(t),e.activeFormattingElements.clearToLastMarker(),e.insertionMode=IN_ROW_MODE):t===$.TABLE||t===$.TBODY||t===$.TFOOT||t===$.THEAD||t===$.TR?e.openElements.hasInTableScope(t)&&(e._closeTableCell(),e._processToken(n)):t!==$.BODY&&t!==$.CAPTION&&t!==$.COL&&t!==$.COLGROUP&&t!==$.HTML&&endTagInBody(e,n)}function startTagInSelect(e,n){const t=n.tagName;t===$.HTML?startTagInBody(e,n):t===$.OPTION?(e.openElements.currentTagName===$.OPTION&&e.openElements.pop(),e._insertElement(n,NS.HTML)):t===$.OPTGROUP?(e.openElements.currentTagName===$.OPTION&&e.openElements.pop(),e.openElements.currentTagName===$.OPTGROUP&&e.openElements.pop(),e._insertElement(n,NS.HTML)):t===$.INPUT||t===$.KEYGEN||t===$.TEXTAREA||t===$.SELECT?e.openElements.hasInSelectScope($.SELECT)&&(e.openElements.popUntilTagNamePopped($.SELECT),e._resetInsertionMode(),t!==$.SELECT&&e._processToken(n)):t!==$.SCRIPT&&t!==$.TEMPLATE||startTagInHead(e,n)}function endTagInSelect(e,n){const t=n.tagName;if(t===$.OPTGROUP){const n=e.openElements.items[e.openElements.stackTop-1],t=n&&e.treeAdapter.getTagName(n);e.openElements.currentTagName===$.OPTION&&t===$.OPTGROUP&&e.openElements.pop(),e.openElements.currentTagName===$.OPTGROUP&&e.openElements.pop()}else t===$.OPTION?e.openElements.currentTagName===$.OPTION&&e.openElements.pop():t===$.SELECT&&e.openElements.hasInSelectScope($.SELECT)?(e.openElements.popUntilTagNamePopped($.SELECT),e._resetInsertionMode()):t===$.TEMPLATE&&endTagInHead(e,n)}function startTagInSelectInTable(e,n){const t=n.tagName;t===$.CAPTION||t===$.TABLE||t===$.TBODY||t===$.TFOOT||t===$.THEAD||t===$.TR||t===$.TD||t===$.TH?(e.openElements.popUntilTagNamePopped($.SELECT),e._resetInsertionMode(),e._processToken(n)):startTagInSelect(e,n)}function endTagInSelectInTable(e,n){const t=n.tagName;t===$.CAPTION||t===$.TABLE||t===$.TBODY||t===$.TFOOT||t===$.THEAD||t===$.TR||t===$.TD||t===$.TH?e.openElements.hasInTableScope(t)&&(e.openElements.popUntilTagNamePopped($.SELECT),e._resetInsertionMode(),e._processToken(n)):endTagInSelect(e,n)}function startTagInTemplate(e,n){const t=n.tagName;if(t===$.BASE||t===$.BASEFONT||t===$.BGSOUND||t===$.LINK||t===$.META||t===$.NOFRAMES||t===$.SCRIPT||t===$.STYLE||t===$.TEMPLATE||t===$.TITLE)startTagInHead(e,n);else{const o=TEMPLATE_INSERTION_MODE_SWITCH_MAP[t]||IN_BODY_MODE;e._popTmplInsertionMode(),e._pushTmplInsertionMode(o),e.insertionMode=o,e._processToken(n)}}function endTagInTemplate(e,n){n.tagName===$.TEMPLATE&&endTagInHead(e,n)}function eofInTemplate(e,n){e.openElements.tmplCount>0?(e.openElements.popUntilTagNamePopped($.TEMPLATE),e.activeFormattingElements.clearToLastMarker(),e._popTmplInsertionMode(),e._resetInsertionMode(),e._processToken(n)):e.stopped=!0}function startTagAfterBody(e,n){n.tagName===$.HTML?startTagInBody(e,n):tokenAfterBody(e,n)}function endTagAfterBody(e,n){n.tagName===$.HTML?e.fragmentContext||(e.insertionMode=AFTER_AFTER_BODY_MODE):tokenAfterBody(e,n)}function tokenAfterBody(e,n){e.insertionMode=IN_BODY_MODE,e._processToken(n)}function startTagInFrameset(e,n){const t=n.tagName;t===$.HTML?startTagInBody(e,n):t===$.FRAMESET?e._insertElement(n,NS.HTML):t===$.FRAME?(e._appendElement(n,NS.HTML),n.ackSelfClosing=!0):t===$.NOFRAMES&&startTagInHead(e,n)}function endTagInFrameset(e,n){n.tagName!==$.FRAMESET||e.openElements.isRootHtmlElementCurrent()||(e.openElements.pop(),e.fragmentContext||e.openElements.currentTagName===$.FRAMESET||(e.insertionMode=AFTER_FRAMESET_MODE))}function startTagAfterFrameset(e,n){const t=n.tagName;t===$.HTML?startTagInBody(e,n):t===$.NOFRAMES&&startTagInHead(e,n)}function endTagAfterFrameset(e,n){n.tagName===$.HTML&&(e.insertionMode=AFTER_AFTER_FRAMESET_MODE)}function startTagAfterAfterBody(e,n){n.tagName===$.HTML?startTagInBody(e,n):tokenAfterAfterBody(e,n)}function tokenAfterAfterBody(e,n){e.insertionMode=IN_BODY_MODE,e._processToken(n)}function startTagAfterAfterFrameset(e,n){const t=n.tagName;t===$.HTML?startTagInBody(e,n):t===$.NOFRAMES&&startTagInHead(e,n)}function nullCharacterInForeignContent(e,n){n.chars=unicode.REPLACEMENT_CHARACTER,e._insertCharacters(n)}function characterInForeignContent(e,n){e._insertCharacters(n),e.framesetOk=!1}function startTagInForeignContent(e,n){if(foreignContent.causesExit(n)&&!e.fragmentContext){for(;e.treeAdapter.getNamespaceURI(e.openElements.current)!==NS.HTML&&!e._isIntegrationPoint(e.openElements.current);)e.openElements.pop();e._processToken(n)}else{const t=e._getAdjustedCurrentElement(),o=e.treeAdapter.getNamespaceURI(t);o===NS.MATHML?foreignContent.adjustTokenMathMLAttrs(n):o===NS.SVG&&(foreignContent.adjustTokenSVGTagName(n),foreignContent.adjustTokenSVGAttrs(n)),foreignContent.adjustTokenXMLAttrs(n),n.selfClosing?e._appendElement(n,o):e._insertElement(n,o),n.ackSelfClosing=!0}}function endTagInForeignContent(e,n){for(let t=e.openElements.stackTop;t>0;t--){const o=e.openElements.items[t];if(e.treeAdapter.getNamespaceURI(o)===NS.HTML){e._processToken(n);break}if(e.treeAdapter.getTagName(o).toLowerCase()===n.tagName){e.openElements.popUntilElementPopped(o);break}}}module.exports=Parser;