"use strict";const HTML=require("../common/html"),$=HTML.TAG_NAMES,NS=HTML.NAMESPACES;function isImpliedEndTagRequired(e){switch(e.length){case 1:return e===$.P;case 2:return e===$.RB||e===$.RP||e===$.RT||e===$.DD||e===$.DT||e===$.LI;case 3:return e===$.RTC;case 6:return e===$.OPTION;case 8:return e===$.OPTGROUP}return!1}function isImpliedEndTagRequiredThoroughly(e){switch(e.length){case 1:return e===$.P;case 2:return e===$.RB||e===$.RP||e===$.RT||e===$.DD||e===$.DT||e===$.LI||e===$.TD||e===$.TH||e===$.TR;case 3:return e===$.RTC;case 5:return e===$.TBODY||e===$.TFOOT||e===$.THEAD;case 6:return e===$.OPTION;case 7:return e===$.CAPTION;case 8:return e===$.OPTGROUP||e===$.COLGROUP}return!1}function isScopingElement(e,t){switch(e.length){case 2:if(e===$.TD||e===$.TH)return t===NS.HTML;if(e===$.MI||e===$.MO||e===$.MN||e===$.MS)return t===NS.MATHML;break;case 4:if(e===$.HTML)return t===NS.HTML;if(e===$.DESC)return t===NS.SVG;break;case 5:if(e===$.TABLE)return t===NS.HTML;if(e===$.MTEXT)return t===NS.MATHML;if(e===$.TITLE)return t===NS.SVG;break;case 6:return(e===$.APPLET||e===$.OBJECT)&&t===NS.HTML;case 7:return(e===$.CAPTION||e===$.MARQUEE)&&t===NS.HTML;case 8:return e===$.TEMPLATE&&t===NS.HTML;case 13:return e===$.FOREIGN_OBJECT&&t===NS.SVG;case 14:return e===$.ANNOTATION_XML&&t===NS.MATHML}return!1}class OpenElementStack{constructor(e,t){this.stackTop=-1,this.items=[],this.current=e,this.currentTagName=null,this.currentTmplContent=null,this.tmplCount=0,this.treeAdapter=t}_indexOf(e){let t=-1;for(let r=this.stackTop;r>=0;r--)if(this.items[r]===e){t=r;break}return t}_isInTemplate(){return this.currentTagName===$.TEMPLATE&&this.treeAdapter.getNamespaceURI(this.current)===NS.HTML}_updateCurrentElement(){this.current=this.items[this.stackTop],this.currentTagName=this.current&&this.treeAdapter.getTagName(this.current),this.currentTmplContent=this._isInTemplate()?this.treeAdapter.getTemplateContent(this.current):null}push(e){this.items[++this.stackTop]=e,this._updateCurrentElement(),this._isInTemplate()&&this.tmplCount++}pop(){this.stackTop--,this.tmplCount>0&&this._isInTemplate()&&this.tmplCount--,this._updateCurrentElement()}replace(e,t){const r=this._indexOf(e);this.items[r]=t,r===this.stackTop&&this._updateCurrentElement()}insertAfter(e,t){const r=this._indexOf(e)+1;this.items.splice(r,0,t),r===++this.stackTop&&this._updateCurrentElement()}popUntilTagNamePopped(e){for(;this.stackTop>-1;){const t=this.currentTagName,r=this.treeAdapter.getNamespaceURI(this.current);if(this.pop(),t===e&&r===NS.HTML)break}}popUntilElementPopped(e){for(;this.stackTop>-1;){const t=this.current;if(this.pop(),t===e)break}}popUntilNumberedHeaderPopped(){for(;this.stackTop>-1;){const e=this.currentTagName,t=this.treeAdapter.getNamespaceURI(this.current);if(this.pop(),e===$.H1||e===$.H2||e===$.H3||e===$.H4||e===$.H5||e===$.H6&&t===NS.HTML)break}}popUntilTableCellPopped(){for(;this.stackTop>-1;){const e=this.currentTagName,t=this.treeAdapter.getNamespaceURI(this.current);if(this.pop(),e===$.TD||e===$.TH&&t===NS.HTML)break}}popAllUpToHtmlElement(){this.stackTop=0,this._updateCurrentElement()}clearBackToTableContext(){for(;this.currentTagName!==$.TABLE&&this.currentTagName!==$.TEMPLATE&&this.currentTagName!==$.HTML||this.treeAdapter.getNamespaceURI(this.current)!==NS.HTML;)this.pop()}clearBackToTableBodyContext(){for(;this.currentTagName!==$.TBODY&&this.currentTagName!==$.TFOOT&&this.currentTagName!==$.THEAD&&this.currentTagName!==$.TEMPLATE&&this.currentTagName!==$.HTML||this.treeAdapter.getNamespaceURI(this.current)!==NS.HTML;)this.pop()}clearBackToTableRowContext(){for(;this.currentTagName!==$.TR&&this.currentTagName!==$.TEMPLATE&&this.currentTagName!==$.HTML||this.treeAdapter.getNamespaceURI(this.current)!==NS.HTML;)this.pop()}remove(e){for(let t=this.stackTop;t>=0;t--)if(this.items[t]===e){this.items.splice(t,1),this.stackTop--,this._updateCurrentElement();break}}tryPeekProperlyNestedBodyElement(){const e=this.items[1];return e&&this.treeAdapter.getTagName(e)===$.BODY?e:null}contains(e){return this._indexOf(e)>-1}getCommonAncestor(e){let t=this._indexOf(e);return--t>=0?this.items[t]:null}isRootHtmlElementCurrent(){return 0===this.stackTop&&this.currentTagName===$.HTML}hasInScope(e){for(let t=this.stackTop;t>=0;t--){const r=this.treeAdapter.getTagName(this.items[t]),s=this.treeAdapter.getNamespaceURI(this.items[t]);if(r===e&&s===NS.HTML)return!0;if(isScopingElement(r,s))return!1}return!0}hasNumberedHeaderInScope(){for(let e=this.stackTop;e>=0;e--){const t=this.treeAdapter.getTagName(this.items[e]),r=this.treeAdapter.getNamespaceURI(this.items[e]);if((t===$.H1||t===$.H2||t===$.H3||t===$.H4||t===$.H5||t===$.H6)&&r===NS.HTML)return!0;if(isScopingElement(t,r))return!1}return!0}hasInListItemScope(e){for(let t=this.stackTop;t>=0;t--){const r=this.treeAdapter.getTagName(this.items[t]),s=this.treeAdapter.getNamespaceURI(this.items[t]);if(r===e&&s===NS.HTML)return!0;if((r===$.UL||r===$.OL)&&s===NS.HTML||isScopingElement(r,s))return!1}return!0}hasInButtonScope(e){for(let t=this.stackTop;t>=0;t--){const r=this.treeAdapter.getTagName(this.items[t]),s=this.treeAdapter.getNamespaceURI(this.items[t]);if(r===e&&s===NS.HTML)return!0;if(r===$.BUTTON&&s===NS.HTML||isScopingElement(r,s))return!1}return!0}hasInTableScope(e){for(let t=this.stackTop;t>=0;t--){const r=this.treeAdapter.getTagName(this.items[t]);if(this.treeAdapter.getNamespaceURI(this.items[t])===NS.HTML){if(r===e)return!0;if(r===$.TABLE||r===$.TEMPLATE||r===$.HTML)return!1}}return!0}hasTableBodyContextInTableScope(){for(let e=this.stackTop;e>=0;e--){const t=this.treeAdapter.getTagName(this.items[e]);if(this.treeAdapter.getNamespaceURI(this.items[e])===NS.HTML){if(t===$.TBODY||t===$.THEAD||t===$.TFOOT)return!0;if(t===$.TABLE||t===$.HTML)return!1}}return!0}hasInSelectScope(e){for(let t=this.stackTop;t>=0;t--){const r=this.treeAdapter.getTagName(this.items[t]);if(this.treeAdapter.getNamespaceURI(this.items[t])===NS.HTML){if(r===e)return!0;if(r!==$.OPTION&&r!==$.OPTGROUP)return!1}}return!0}generateImpliedEndTags(){for(;isImpliedEndTagRequired(this.currentTagName);)this.pop()}generateImpliedEndTagsThoroughly(){for(;isImpliedEndTagRequiredThoroughly(this.currentTagName);)this.pop()}generateImpliedEndTagsWithExclusion(e){for(;isImpliedEndTagRequired(this.currentTagName)&&this.currentTagName!==e;)this.pop()}}module.exports=OpenElementStack;